#include "mainwindow.h"
#include "ui_mainwindow.h"


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    m_state = 0;

    m_timer = new MyThread(this);
    connect(m_timer, &MyThread::PleaseUpdate, this, &MainWindow::Update);
    m_timer->start();
}

MainWindow::~MainWindow()
{
    m_timer->terminate();
    m_timer->wait();
    delete m_timer;
    delete ui;
}

void MainWindow::Update() {     //  Slot.
    ui->label->setText(QString::number(m_state++));
}


MyThread::MyThread(MainWindow *parent) : QThread(parent) { }

void MyThread::run() {
    boost::asio::io_service l_io;
    boost::asio::deadline_timer l_t(l_io);

    while (true) {
        l_t.expires_from_now(boost::posix_time::milliseconds(100));
        emit PleaseUpdate();
        l_t.wait();
    }
}
